Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 2050281 - Review Request: python-pyABF - Python library for reading files in Axon Binary Format (ABF)
Summary: Review Request: python-pyABF - Python library for reading files in Axon Binar...
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Ankur Sinha (FranciscoD)
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: fedora-neuro, NeuroFedora
TreeView+ depends on / blocked
 
Reported: 2022-02-03 15:54 UTC by Vanessa Christopher
Modified: 2022-10-24 14:02 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2022-10-24 14:02:54 UTC
Type: ---
Embargoed:
sanjay.ankur: fedora-review+


Attachments (Terms of Use)

Description Vanessa Christopher 2022-02-03 15:54:29 UTC
Spec URL: https://pagure.io/python-pyABF/raw/master/f/python-pyABF.spec
SRPM URL: https://pagure.io/python-pyABF/raw/master/f/python-pyABF-2.3.5-1.fc36.src.rpm
Description: Python library for reading files in Axon Binary Format (ABF)
Fedora Account System Username:vanessakris

Comment 1 Adeleye Opeyemi 2022-02-25 21:16:17 UTC
Package Review
==============
This looks good but needs a few change
Issues:
=======
- Dist tag is present.
-package does not include text of license in its own file
      rpm -ql --licensefiles -p ./python3-pyABF-2.3.5.fc36.noarch.rpm
- Changelog-name tag absent 



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT License", "Unknown or generated", "*No copyright* MIT
     License". 629 files have unknown license. Detailed output of
     licensecheck in /home/ope/contributions/reviews/2050281-python-
     pyABF/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[?]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[-]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff).
     See: (this test has no URL)
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
rpmlint srpm-unpacked/*.spec results/*.rpm
rpmlint: 2.2.0
configuration:
    /usr/lib/python3.10/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/licenses.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 32, packages: 3

python-pyABF.src: W: strange-permission python-pyABF.spec 600
python-pyABF.src: E: no-changelogname-tag
python3-pyABF.noarch: E: no-changelogname-tag
 2 packages and 1 specfiles checked; 2 errors, 1 warnings, 2 badness; has taken 5.5 s 



Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Source checksums
----------------
https://github.com/swharden/pyABF/archive/2.3.5/python-pyABF-2.3.5.tar.gz :
  CHECKSUM(SHA256) this package     : 7b0fa94f371acabc435d0dbf6e7ebd96780c532afe8cf7b080fd2d1cffff97c9
  CHECKSUM(SHA256) upstream package : 7b0fa94f371acabc435d0dbf6e7ebd96780c532afe8cf7b080fd2d1cffff97c9


Requires
--------
python3-pyABF (rpmlib, GLIBC filtered):
    python(abi)
    python3.10dist(matplotlib)
    python3.10dist(numpy)
    python3.10dist(pytest)



Provides
--------
python3-pyABF:
    python-pyABF
    python3-pyABF
    python3.10-pyABF
    python3.10dist(pyabf)
    python3dist(pyabf)



Diff spec file in url and in SRPM
---------------------------------
--- /home/ope/contributions/reviews/2050281-python-pyABF/srpm/python-pyABF.spec	2022-02-21 04:12:35.604825840 -0500
+++ /home/ope/contributions/reviews/2050281-python-pyABF/srpm-unpacked/python-pyABF.spec	2022-02-03 10:14:50.000000000 -0500
@@ -1,2 +1,11 @@
+## START: Set by rpmautospec
+## (rpmautospec version 0.2.5)
+%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
+    release_number = 1;
+    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
+    print(release_number + base_release_number - 1);
+}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
+## END: Set by rpmautospec
+
 Name:           python-pyABF
 Version:        2.3.5
@@ -50,3 +59,3 @@
 
 %changelog
-%autochangelog
+


Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -b 2050281
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: R, C/C++, Java, SugarActivity, PHP, Haskell, fonts, Perl, Ocaml
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 2 Vanessa Christopher 2022-03-10 13:43:10 UTC
Updated 

Spec URL: https://pagure.io/python-pyABF/blob/master/f/python-pyABF.spec
SRPM URL: https://pagure.io/python-pyABF/blob/master/f/python-pyABF-2.3.5-2.fc37.src.rpm
Description: Python library for reading files in Axon Binary Format (ABF)
Fedora Account System Username:vanessakris

Comment 3 Adeleye Opeyemi 2022-03-18 12:57:00 UTC
Hi vanessa, please change the link from blob to raw.

Comment 4 Vanessa Christopher 2022-03-20 06:56:24 UTC
oh sorry :XD 

Spec URL: https://pagure.io/python-pyABF/raw/master/f/python-pyABF.spec
SRPM URL: https://pagure.io/python-pyABF/raw/master/f/python-pyABF-2.3.5-2.fc37.src.rpm
Description: Python library for reading files in Axon Binary Format (ABF)
Fedora Account System Username:vanessakris

Comment 5 Ankur Sinha (FranciscoD) 2022-04-25 13:37:47 UTC
Hiya Adeleye,

Would you be able to continue this review when you have some time please?

Cheers,
Ankur

Comment 6 Package Review 2022-05-26 00:45:17 UTC
This is an automatic action taken by review-stats script.

The ticket reviewer failed to clear the NEEDINFO flag in a month.
As per https://fedoraproject.org/wiki/Policy_for_stalled_package_reviews
we reset the status and the assignee of this ticket.

Comment 7 Ankur Sinha (FranciscoD) 2022-05-27 14:00:43 UTC
I'll complete this one :)

Comment 8 Ankur Sinha (FranciscoD) 2022-07-05 08:46:53 UTC
Hrm, looks like there's a test failure now, probably something changed with py3.11 or the new pytest:

=================================== FAILURES ===================================
____________________ test_findStimulusFile_foundIfPathGiven ____________________
    def test_findStimulusFile_foundIfPathGiven():
        """The user can tell pyABF where to look for stimulus files."""
    
        abf = pyabf.ABF(ABF_PATH, stimulusFileFolder=STIM_FOLDER)
        stimulus = abf.stimulusByChannel[0]
        waveform = stimulus.stimulusWaveform(stimulusSweep=0)
    
        assert isinstance(waveform, np.ndarray)
        assert not np.isnan(waveform).any()
>       assert pytest.approx(waveform[100000], 76.261)
E       AssertionError: approx() is not supported in a boolean context.
E       Did you mean: `assert a == approx(b)`?
tests/test_stimulus.py:47: AssertionError
=============================== warnings summary ===============================

Luckily, this seems to have been fixed in the code. Can you please include this patch and see how it goes?

https://github.com/swharden/pyABF/commit/9cd568066b5ff8d6079e2d8cf8af388066cc9b79

To include the patch:

- download the patch from here: https://github.com/swharden/pyABF/commit/9cd568066b5ff8d6079e2d8cf8af388066cc9b79.patch
- add it to git repo: `git add 9cd568066b5ff8d6079e2d8cf8af388066cc9b79.patch`
- Add it to the spec as Patch0: https://github.com/swharden/pyABF/commit/9cd568066b5ff8d6079e2d8cf8af388066cc9b79.patch
- Add `git-core` as a new BuildRequires
- Add `-S git` to the `%autosetup` command


Cheers,
Ankur

Comment 10 Ankur Sinha (FranciscoD) 2022-08-24 09:04:19 UTC
(In reply to Vanessa Christopher from comment #9)
> @sanjay.ankur 
> 
> Updated 
> 
> Spec URL: https://pagure.io/python-pyABF/raw/master/f/python-pyABF.spec
> SRPM URL:
> https://pagure.io/python-pyABF/raw/master/f/python-pyABF-2.3.5-3.fc38.src.rpm

I think that looks good.

In the meantime, though, they've released 2.3.6 which includes the patch. So you can update to that and drop the patch XD

https://github.com/swharden/pyABF/compare/2.3.5...2.3.6

Comment 11 Vanessa Christopher 2022-08-24 09:30:15 UTC
XD Alright, on it.

Comment 13 Ankur Sinha (FranciscoD) 2022-08-24 12:44:28 UTC
Package is now good! XXX APPROVED !! XXX

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT License", "Unknown or generated", "*No copyright* MIT
     License". 621 files have unknown license. Detailed output of
     licensecheck in /home/asinha/dump/fedora-reviews/2050281-python-
     pyABF/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
^
All tests pass

[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff).
     See: (this test has no URL)

^
This is because we're using rpmautospec, so it's OK.

[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Cannot parse rpmlint output:

Ran manually:

python-pyABF.spec:68: E: forbidden-controlchar-found %changelog: - added patch 9cd568066b5ff8d6079e2d8cf8af388066cc9b79~

python-pyABF.src: E: forbidden-controlchar-found %changelog : - added patch 9cd568066b5ff8d6079e2d8cf8af388066cc9b79~
python3-pyABF.noarch: E: forbidden-controlchar-found %changelog : - added patch 9cd568066b5ff8d6079e2d8cf8af388066cc9b79~


^Vanessa, I think it's the `~` that it's complaining about. Not sure if this is a problem as a line in the changelog, but you could reword the commit when you're doing the rebase to import into src.fedoraproject.org to modify the commit message and remove the `~`. (ping me if you're unsure on how to do the rewording)


Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:

^
meh.


Source checksums
----------------
https://github.com/swharden/pyABF/archive/2.3.6/python-pyABF-2.3.6.tar.gz :
  CHECKSUM(SHA256) this package     : 662989e7a5bc7f8c3279326fc4bc3efcaabbd92a2f0d857e082064ed0cbdf095
  CHECKSUM(SHA256) upstream package : 662989e7a5bc7f8c3279326fc4bc3efcaabbd92a2f0d857e082064ed0cbdf095


Requires
--------
python3-pyABF (rpmlib, GLIBC filtered):
    python(abi)
    python3.11dist(matplotlib)
    python3.11dist(numpy)
    python3.11dist(pytest)



Provides
--------
python3-pyABF:
    python-pyABF
    python3-pyABF
    python3.11-pyABF
    python3.11dist(pyabf)
    python3dist(pyabf)



Diff spec file in url and in SRPM
---------------------------------
--- /home/asinha/dump/fedora-reviews/2050281-python-pyABF/srpm/python-pyABF.spec	2022-08-24 13:06:40.344974840 +0100
+++ /home/asinha/dump/fedora-reviews/2050281-python-pyABF/srpm-unpacked/python-pyABF.spec	2022-08-24 12:13:43.000000000 +0100
@@ -1,2 +1,11 @@
+## START: Set by rpmautospec
+## (rpmautospec version 0.3.0)
+%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
+    release_number = 1;
+    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
+    print(release_number + base_release_number - 1);
+}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
+## END: Set by rpmautospec
+
 Name:           python-pyABF
 Version:        2.3.6
@@ -50,3 +59,16 @@
 
 %changelog
-%autochangelog
+* Wed Aug 24 2022 Vanessa Kris <vanessaigwe1> 2.3.6-1
+- Uncommitted changes
+
+* Tue Aug 23 2022 Vanessa Kris <vanessaigwe1> 2.3.5-4
+- added patch
+
+* Mon Aug 08 2022 Vanessa Kris <vanessaigwe1> 2.3.5-3
+- added patch [200~9cd568066b5ff8d6079e2d8cf8af388066cc9b79~
+
+* Wed Mar 02 2022 Vanessa_kris <vanessaigwe1> 2.3.5-2
+- f37 build
+
+* Thu Feb 03 2022 Vanessa_kris <vanessaigwe1> 2.3.5-1
+- initial build


Generated by fedora-review 0.8.0 (e988316) last change: 2022-04-07
Command line :/usr/bin/fedora-review -b 2050281
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Python, Shell-api
Disabled plugins: PHP, Java, R, fonts, Ocaml, Haskell, Perl, C/C++, SugarActivity
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Vanessa, please continue from the import (steps here: https://pagure.io/fedora-docs/package-maintainer-docs/issue/56). When you run `git rebase -i rawhide`, you will see "reword" as an option for the commits---you can use that to remove the `~` symbol from the patch commit which is making rpmlint throw an error.

Comment 14 Tomas Hrcka 2022-08-25 06:42:10 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-pyABF

Comment 15 Fedora Update System 2022-09-26 14:16:13 UTC
FEDORA-2022-1a13497ca7 has been submitted as an update to Fedora 36. https://bodhi.fedoraproject.org/updates/FEDORA-2022-1a13497ca7


Note You need to log in before you can comment on or make changes to this bug.